<?php
/**
 * @package	HikaShop for Joomla!
 * @version	2.5.0
 * @author	hikashop.com
 * @copyright	(C) 2010-2015 HIKARI SOFTWARE. All rights reserved.
 * @license	GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php
class plgHikashopGog_products extends JPlugin{
	function plgHikashopGog_products(&$subject, $config){
		parent::__construct($subject, $config);
	}

	function onHikashopCronTrigger(&$messages){
		if(hikashop_level(1)){
			$pluginsClass = hikashop_get('class.plugins');
			$plugin = $pluginsClass->getByName('hikashop','gog_products');

			if( empty($plugin->params['enable_auto_update']) && empty($plugin->params['local_path'])){
				return true;
			}

			if(empty($plugin->params['frequency'])){
				$plugin->params['frequency'] = 600;
			}
			if(!empty($plugin->params['last_cron_update']) && $plugin->params['last_cron_update']+$plugin->params['frequency']>time()){
				return true;
			}

			$plugin->params['last_cron_update']=time();
			$pluginsClass->save($plugin);
			$pluginsClass->loadParams($plugin);

			$app = JFactory::getApplication();
			
			if(empty($plugin->params['enable_auto_update']) ){
				return true;
			}
			if(!empty($plugin->params['gog_password']) && !empty($plugin->params['user_name']) && !empty($plugin->params['file_name']) && !empty($plugin->params['local_path'])){
				$pwd=$plugin->params['gog_password'];
				$user=$plugin->params['user_name'];
				$name=$plugin->params['file_name'];
				$path=$this->_getRelativePath($plugin->params['local_path']);
			}
			else{
				return true;
			}
			if($this->_connectionToGoGDB($user,$pwd, $plugin, $path, $name)){
				$message = 'Product information retrieved from Gallery of Guns';
				$messages[] = $message;
				$app->enqueueMessage($message);
			}
		}
	}

	function _getRelativePath($path){
		$relativePath=str_replace(JPATH_ROOT.DS,'',$path);
		return $relativePath;
	}

	function _connectionToGoGDB($login, $pwd, $plugin, $path, $name){
		jimport('joomla.client.ftp');
		$ftp = new JFTP();
		$conn_id=$ftp->connect("ftp.davidsonsinventory.com/inventory/");
		$ftp->login($login, $pwd);
		$ftp->get($path, $name);
	}

}